/*
     Aglaophone -- a system for real time audio processing
     Copyright (C) 1998-1999 Stephen D. Holland
 
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
 
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.border.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class bits_panel extends JPanel implements ChangeListener,ItemListener {
  static JFrame frame;
  static bits_panel panel;
    
  
  static String Title="bits";
  static boolean nohighbits=false;
  static boolean muteoption=false;
  static int PanelX,PanelY;

  public final static Border emptyBorder10 = new EmptyBorder(10,10,10,10);
  static Thread consoleInputThread;
  public final static Dimension hpad10 = new Dimension(10,1);
  public final static Dimension vpad10 = new Dimension(1,10);
   

  JSlider HighOrderBits;
  JSlider LowOrderBits; 

  JCheckBox LowDisable;
  JCheckBox HighDisable;

  JCheckBox LowMute;

  int HighBits=0;
  int LowBits=0;

  boolean HighDisabled=false;
  boolean LowDisabled=false;  

  boolean LowMuted=false;

  void sethighdisabled(boolean val)
  {
    if (val != HighDisabled) {
      System.out.println("HighDisabled=" + ((val) ? 1:0));
      HighDisabled=val;
      HighDisable.setSelected(val);
    }
  }


  void setlowmuted(boolean val)
  {
    if (val != LowMuted) {
      System.out.println("Muted=" + ((val) ? 1:0));
      LowMuted=val;
      LowMute.setSelected(val);
    }
  }

  void sethighbits(int num) {
    if (num != HighBits) {
      System.out.println("HighBits="+num);
      HighBits=num;
      HighOrderBits.setValue(HighBits);
    }
    
  }
  void setlowdisabled(boolean val)
  {
    if (val != LowDisabled) {
      System.out.println("LowDisabled=" + ((val) ? 1:0));
      LowDisabled=val;
      LowDisable.setSelected(val);
    }
  }

  void setlowbits(int num) {
    if (num != LowBits) {
      System.out.println("LowBits="+num);
   
      LowBits=num;
      
      LowOrderBits.setValue(LowBits);
    }
    
  }

  public bits_panel() {
    setBorder(emptyBorder10);
    if (nohighbits) {
	setLayout(new GridLayout(1,2));
    } else {
	setLayout(new GridLayout(2,2));
    }

    //    JPanel HOPanel=new JPanel();
    //HOPanel.setLayout(new BoxLayout(HOPanel,BoxLayout.X_AXIS));

    
    if (!nohighbits) {
	JLabel HOLabel=new JLabel("Remove high-order bits:");
	
	HighOrderBits=new JSlider(JSlider.HORIZONTAL,0,16,HighBits);
	HighOrderBits.addChangeListener(this);
	HighOrderBits.setPaintTicks(true);
	HighOrderBits.setMajorTickSpacing(5);
	HighOrderBits.setMinorTickSpacing(1);
	
	HighOrderBits.setPaintLabels( true );
	HighOrderBits.setSnapToTicks( true );
	
	HighDisable=new JCheckBox("Disable",false);
	HighDisable.setAlignmentX(JCheckBox.LEFT_ALIGNMENT);
	HighDisable.addItemListener(this);

	/*	HighMute=new JCheckBox("Mute",false);
	HighMute.setAlignmentX(JCheckBox.LEFT_ALIGNMENT);
	HighMute.addItemListener(this);
	*/
	JPanel CheckBoxPanel=new JPanel();
	CheckBoxPanel.setLayout(new BoxLayout(CheckBoxPanel,BoxLayout.X_AXIS));
	/*CheckBoxPanel.add(HighMute);*/
	CheckBoxPanel.add(HighDisable);

	JPanel LeftHighPanel=new JPanel();
	HOLabel.setAlignmentX(HOLabel.CENTER_ALIGNMENT);
	LeftHighPanel.setLayout(new BoxLayout(LeftHighPanel,BoxLayout.Y_AXIS));
	LeftHighPanel.add(HOLabel);
	LeftHighPanel.add(CheckBoxPanel);
	
	add(LeftHighPanel);
	add(HighOrderBits);
    }

    JLabel LOLabel=new JLabel("Remove low-order bits:");
    
    LowOrderBits=new JSlider(JSlider.HORIZONTAL,0,16,LowBits);
    LowOrderBits.addChangeListener(this);
    LowOrderBits.setPaintTicks(true);
    LowOrderBits.setMajorTickSpacing(5);
    LowOrderBits.setMinorTickSpacing(1);

    LowOrderBits.setPaintLabels( true );
    LowOrderBits.setSnapToTicks( true );


    LowDisable=new JCheckBox("Disable",false);
    LowDisable.setAlignmentX(JCheckBox.LEFT_ALIGNMENT);
    LowDisable.addItemListener(this);

    if (muteoption) {
	LowMute=new JCheckBox("Mute",false);
	LowMute.setAlignmentX(JCheckBox.LEFT_ALIGNMENT);
	LowMute.addItemListener(this);
    }
    JPanel LowCheckBoxPanel=new JPanel();
    LowCheckBoxPanel.setLayout(new BoxLayout(LowCheckBoxPanel,BoxLayout.X_AXIS));
    LowCheckBoxPanel.add(LowDisable);
    if (muteoption) LowCheckBoxPanel.add(LowMute);


    LOLabel.setAlignmentX(LOLabel.CENTER_ALIGNMENT);

    JPanel LeftLowPanel=new JPanel();
    LeftLowPanel.setLayout(new BoxLayout(LeftLowPanel,BoxLayout.Y_AXIS));
    LeftLowPanel.add(LOLabel);
    LeftLowPanel.add(LowCheckBoxPanel);    

    add(LeftLowPanel);
    add(LowOrderBits);

    
  }

  public void stateChanged(ChangeEvent event) {
    JComponent c = (JComponent) event.getSource();
    if(c == HighOrderBits) {
      /*if (!HighOrderBits.getValueIsAdjusting()) {*/
      sethighbits(HighOrderBits.getValue());
      /*}*/
      
    } else if (c==LowOrderBits) {
      /*if (!LowOrderBits.getValueIsAdjusting()) {*/
      setlowbits(LowOrderBits.getValue());
      /*}*/

    }
  }

  public void itemStateChanged(ItemEvent event) {
    JComponent c = (JComponent) event.getSource();
    if (c==LowDisable) {
      setlowdisabled(LowDisable.isSelected());
    }
    if (c==HighDisable) {
      sethighdisabled(HighDisable.isSelected());
    }

    
    if (c==LowMute) {
      setlowmuted(LowMute.isSelected());
    }
  }

  static class ConsoleInput implements Runnable {
    bits_panel panel;
    ConsoleInput(bits_panel parentpanel) {
      panel=parentpanel;
    }

    public void run() {
      /* console input thread begins here */
      /**** WARNING **** Practically everything in this thread
	    (except for reading from stdin) must be synchronized
	    with invokeAndWait(). See
http://java.sun.com/products/jfc/tsc/archive/tech_topics_arch/threads/threads.html
for details. */
      
      try {
	Reader r = new BufferedReader(new InputStreamReader(System.in));
	StreamTokenizer st = new StreamTokenizer(r);
	int ttype;
	
	/* Example of invokeandwait(): 
	
	SwingUtilities.invokeAndWait(new Runnable() {public void run() {
	  System.out.println("Doing invokeAndWait");
	}});
	*/
	
	
	st.resetSyntax();
	st.wordChars('a','z');
	st.wordChars('A','Z');
	st.wordChars('\u00A0','\u00ff');
	st.whitespaceChars('\u0000','\u0020');
	st.quoteChar('"');
	st.parseNumbers();
	st.eolIsSignificant(true);
	
	/* read in, and process, tokens */
	
	while ((ttype=st.nextToken()) != StreamTokenizer.TT_EOF) {
	  switch(ttype) {
	  case StreamTokenizer.TT_EOL:
	    break;
	    
	  case StreamTokenizer.TT_WORD:
	    /* System.err.println("Got "+st.sval); */
	    if (st.sval.compareTo("HighBits")==0) {
	      if (st.nextToken()=='=' && st.nextToken()==st.TT_NUMBER) {	
		final int number=(int)st.nval;
		SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		  panel.sethighbits(number);
		}});
	      }
	    }
	    else if (st.sval.compareTo("LowBits")==0) {
	      if (st.nextToken()=='=' && st.nextToken()==st.TT_NUMBER) {	
		final int number=(int)st.nval;
		SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		  panel.setlowbits(number);
		}});
	      }
	    }
	    else if (st.sval.compareTo("LowDisabled")==0) {
	      if (st.nextToken()=='=' && st.nextToken()==st.TT_NUMBER) {	
		final int number=(int)st.nval;
		SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		  panel.setlowdisabled(number!=0);
		}});
	      }
	    }
	    else if (st.sval.compareTo("HighDisabled")==0) {
	      if (st.nextToken()=='=' && st.nextToken()==st.TT_NUMBER) {	
		final int number=(int)st.nval;
		SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		  panel.sethighdisabled(number!=0);
		}});
	      }
	    }
	    else if (st.sval.compareTo("Muted")==0) {
	      if (st.nextToken()=='=' && st.nextToken()==st.TT_NUMBER) {	
		final int number=(int)st.nval;
		SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		  panel.setlowmuted(number!=0);
		}});
	      }
	    }
	    else if (st.sval.compareTo("title")==0) {
		if (st.nextToken()=='=') {
		    int toktype;
		    toktype=st.nextToken();
		    if (toktype=='"') {
			final String str=st.sval;
			SwingUtilities.invokeAndWait(new Runnable() {public void run() {
			    Title=str;
			}});
			
		    }
		}
	    }
	    else if (st.sval.compareTo("NoHighBits")==0) {
		SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		    nohighbits=true;
		}});
	    }	    
	    else if (st.sval.compareTo("MuteOption")==0) {
		SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		    muteoption=true;
		}});
	    }	    
	    else if (st.sval.compareTo("PanelY")==0) {
	      if (st.nextToken()=='=' && st.nextToken()==st.TT_NUMBER) {	
		final int number=(int)st.nval;
		SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		  PanelY=number;
		}});
	      }
	    }
	    else if (st.sval.compareTo("PanelX")==0) {
	      if (st.nextToken()=='=' && st.nextToken()==st.TT_NUMBER) {	
		final int number=(int)st.nval;
		SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		  PanelX=number;
		}});
	      }
	    }
	    else if (st.sval.compareTo("BeginGUI")==0) {
	      SwingUtilities.invokeAndWait(new Runnable() {public void run() {		  
		  //panel = new bits_panel();

		frame = new JFrame(Title);
		if (PanelX >= 0 && PanelY >= 0) frame.setLocation(PanelX,PanelY);
		frame.addWindowListener(new WindowAdapter() {
		  public void windowClosing(WindowEvent e) {System.exit(0);}
		});
		frame.getContentPane().add("Center", panel);
		frame.pack();
		/* System.err.println("ready to set visible "); */
		frame.setVisible(true); /* No more GUI stuff allowed after this call, 
					   unless thread-synchronized */
		System.out.println("GUIReady");
	      }});
	    }
	    break;
	    
	  default:
	    System.err.println("Got unknown input token: " + ttype);
	    
	  }
	}
	System.exit(0);
      }
      catch(Exception except) {
	System.err.println("Error in input processing thread: "+except);
      }
    }
  }
  

  public static void main(String s[]) {
    ConsoleInput consoleInput;
    
    
    /* System.err.println("main started "); */
    
    try {
      //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
      //UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
    } catch (Exception exc) {
      System.err.println("Error loading Look&Feel: " + exc);
    }
    
    panel = new bits_panel();    
    /* System.err.println("sio_panel created "); */
    

    /* start up the control-input thread */
    
    consoleInput = new ConsoleInput(panel);
    consoleInputThread=new Thread(consoleInput);
    consoleInputThread.start();
  }
}

