/*
     Aglaophone -- a system for real time audio processing
     Copyright (C) 1998-2000 Stephen D. Holland

     This library is free software; you can redistribute it and/or
     modify it under the terms of the GNU Lesser General Public
     License as published by the Free Software Foundation; 
     version 2.1 of the License.

     This library is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     Lesser General Public License for more details.

     You should have received a copy of the GNU Lesser General Public
     License along with this library; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

*/

/* These typedefs are OK for most current platforms */
typedef unsigned char UINT8;
typedef unsigned short UINT16;
typedef unsigned int UINT32;
typedef signed char INT8;
typedef signed short INT16;
typedef signed int INT32;

struct StatusBlk {
  UINT8 MagicByte[6]; /* 6 0x7f bytes signal the start of a status block */
  UINT8 zero; /* one zero byte specifies the termination of the 0x7f's */
  UINT8 NumChannels; /* 1 for mono, 2 for stereo */
  UINT32 SampleRate; /* a 4 byte machine-endian sample rate, in samples/sec */
  UINT16 FrameNumber; /* serial number of the NEXT frame to be transmitted */
  UINT16 BlockSize; /* in (stereo) samples (minimum blocksize is 6) */
}; /* Total length: 16 bytes */


struct DataBlkHeader {
  UINT8 MagicByte[3]; /* 2 0x7f bytes signal the start of a data block */
  UINT8 NextBlockIsStatusBlk; /* 0x01 if the next block will be a status block, zero
				 otherwise */
  UINT32 Reserved; /* new. added 8/12/99. Set to zero */
};

/* 
struct DataBlk {
  struct DataBlkHeader Hdr;
  INT16 Data[BlockSize*NumChannels];
};
*/ /* Total length: 3+1+2*BlockSize*NumChannels */




