/*
     Aglaophone -- a system for real time audio processing
     Copyright (C) 1998-1999 Stephen D. Holland
 
     This library is free software; you can redistribute it and/or
     modify it under the terms of the GNU Lesser General Public
     License as published by the Free Software Foundation; 
     version 2.1 of the License.

     This library is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     Lesser General Public License for more details.

     You should have received a copy of the GNU Lesser General Public
     License along with this library; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

*/

/* NOTE: This include file requires that linklist.h be included first */

#define JAVAPATH "jre1.3.1_01/bin/java" /* path to java executable */

/* find the largest value in a variable-length argument list 
   terminated by -2. */
int maxva(int arg,...);


/* Set the specified file-descriptor to non-blocking i/o */
void setnonblocking(int fd);


void startdebugtimer(void); /* warning: the debugtimer is NON-REENTRANT */
float resultdebugtimer(void);



/* search the command path to find the actual (?) path
   to the command which was run. We do this by opening a 
   pipe to which(1). Be warned that there are race conditions
   by which this might give the path to a different executable
   of the same name (!). But there doesn't seem to be a better way. 
   This routine DOES trace back symbolic links. */
char *find_argv0(char *argv0);



struct queued_outbuffer {
  struct Node Node; /* just in case you want to put this on a list 
		       (not used by the util routines) */
  struct List queue;
  int writefd; /* fd to which we write the queue */
};

struct queued_elem { /* an element of the queued_outbuffer.queue list */
  struct Node Node; /* on the List */
  char *Buffer;
  int BufLen; /* length of buffer, in bytes */
  int BufPos; /* Position in sending */
  /* char RealBuffer[]  -- the data itself goes here, so a single free() frees the 
     structure and the buffer. */
};

struct queued_outbuffer *create_queued_outbuffer(int fd);
void delete_queued_outbuffer(struct queued_outbuffer *queue); /* does not close file descriptor */
int queued_outbuffer_data_available(struct queued_outbuffer *buf);
void write_queued_outbuffer(struct queued_outbuffer *buf);
void queue_outbuffer(struct queued_outbuffer *queue,int priority,char *Data,int Len); 
void qob_printf(struct queued_outbuffer *queue,int priority,char *fmt,...); /* printf to a queued output buffer */
void parserreadchars(int readfd,int (*parsefunc)(int Code),void (*initfunc)(void));
void spawnjava(char *argv0,char *classname,int *writetojava,int *readfromjava);
