/*
     Aglaophone -- a system for real time audio processing
     Copyright (C) 1998-1999 Stephen D. Holland
 
     This library is free software; you can redistribute it and/or
     modify it under the terms of the GNU Lesser General Public
     License as published by the Free Software Foundation; 
     version 2.1 of the License.

     This library is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     Lesser General Public License for more details.

     You should have received a copy of the GNU Lesser General Public
     License along with this library; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

/* this code is no longer used */
void guisendstring(char *string)
{
  int Pos=0;
  int Ret;

  while (Pos < strlen(string)) {
    Ret=write(guioutputfd,string+Pos,strlen(string)-Pos);
    /* fprintf(stderr,"Wrote %d bytes: %s\n",Ret,string+Pos); */
    if (Ret < 0) {
      if (errno==EINTR || errno==EAGAIN) continue;
      else {
	perror("Write error on GUI pipe");
	exit(1);
      }
    }
    else if (Ret==0) {
      /* EOF -- user closed window -- exit silently */
      exit(0);
    } else {
      Pos+=Ret;
    }
  }
}

void guiprintf(char *fmt,...)
{
  va_list ap;
  int Ret=0;
  static char *Buf;
  static int BufSize;
  
  va_start(ap,fmt);
  
  if (!BufSize) {
    BufSize=200;
    Buf=malloc(BufSize);
  }
  
  
  do {
    if (Ret) {
      BufSize <<= 1;
      free(Buf);
      Buf=malloc(BufSize);
    }
    Ret=vsnprintf(Buf,BufSize,fmt,ap);
  } while (Ret==BufSize);
  
  guisendstring(Buf);
  
  va_end(ap);
}


#define RDBUFSIZE 200

void guireadchars(void)
{
  int GotBytes;
  char Buf[RDBUFSIZE];
  int Cnt;
  
  
  do {
    GotBytes=read(guiinputfd,Buf,RDBUFSIZE);
    if (!GotBytes) {
      /* EOF on GUI connection. User has closed us, so we die. */
      exit(0);
    } else if (GotBytes < 0) {
      if (errno==EINTR) continue;
      else if (errno==EWOULDBLOCK || errno==EAGAIN) return; /* no data available */
      else {
	perror("soundcardio/panelinterface/guireadchars");
	exit(1);
      }
    } else {
      for (Cnt=0;Cnt < GotBytes;Cnt++) {
	PCB.input_code=Buf[Cnt];
	/*	  fprintf(stderr,"calling parser with character %c.\n",PCB.input_code);*/
	panelinterface(); /* call parser */
	if (PCB.exit_flag != AG_RUNNING_CODE) {
	  fprintf(stderr,"soundcardio/panelinterface: failed due to parse error. Parser restarted.\n");
	  init_panelinterface(); /* restart parser */
	}
      }
    }
    
  } while (GotBytes > 0);
  
}
