/*
     Aglaophone -- a system for real time audio processing
     Copyright (C) 1998-1999 Stephen D. Holland
 
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
 
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct FilterControlBlock {
  /* Eventually this will contain information from one application of 
     a filter to pass to the next application of the filter, so that
     there is no interruption. */
  /* all data is private */
  int SampleFactor;
  int NumChannels;
  INT32 *WorkBuf; /* Working buffer for sample processing */
  int WorkBufSize; /* number of accumulated samples */
};

struct FilterControlBlock *FilterAndUpsample(INT16 *InputBuf,INT16 *OutputBuf,int UpsampleAmnt,int NumChannels,int OutputBufferSize,struct FilterControlBlock *FCB,int linear /* if set, use linear interpolation rather than filtering */);

struct FilterControlBlock *FilterAndDownsample(INT16 *InputBuf,INT16 *OutputBuf,int DownsampleAmnt,int NumChannels,int InputBufferSize,struct FilterControlBlock *FCB);

void ClearFCB(struct FilterControlBlock *FCB); /* zero out any stored response in the FCB */
