/*
     Aglaophone -- a system for real time audio processing
     Copyright (C) 1998-1999 Stephen D. Holland
 
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
 
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Defines for mode -- must be the same as those in sio_panel.java */
#define SIM_RECORD 0
#define SIM_PLAY 1
#define SIM_DUPLEX 2

extern int Mode; /* SIM_DUPLEX or whatever */


extern int RecordSampleRate; /* sample rate the user has requested (after downsampling) */
extern int RecordNumChannels; /* 2 for stereo, 1 for mono */
extern int RecordBufferSize; /* number of 16 bit (stereo) samples in buffer */

extern int ADCMode;
extern int DACMode;

extern int PlayBufferSize; /* number of 16 bit (stereo) samples in buffer */
extern int NumPlayBuffers;

extern int NextAvailBuffer; /* Which buffer to fill up next */
extern int NextPlayBuffer; /* Next buffer to copy to PlayOutputBuffer */

extern int PlaySampleRate;
extern int PlayUpSample;

extern char *Title; /* Desired window title for control panel */


void BuildPlayBuffers(int BlockSize,int NumBuffers);
void QueueNewRecordRate(int NewSampleRate);
void QueueNewRecordNumChannels(int NewNumChannels);
void QueueNewRecordBufSize(int NewBufferSize);
void QueueNewPlayNumBuffers(int newnum);
void SetADCMode(int Newmode);
void SetDACMode(int Newmode);

