/*
     Aglaophone -- a system for real time audio processing
     Copyright (C) 1998-1999 Stephen D. Holland
 
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
 
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifdef LINUX_OSS
struct soundspec {
  int CardID;
  int Mode;
  int log2fragsize;
  int log2numfrags;
  int Rate;
  int NumChannels;
  int recordsoundfh; /* recordsoundfh and playsoundfh are the only public members */
  int playsoundfh;  /* with OSS the filehandles are always the same */
};
#endif

#ifdef LINUX_ALSA
#include <sys/asoundlib.h>

struct soundspec {
  int CardID;
  int CardDevice;
  int Mode;
  int log2fragsize;
  int log2numfrags;
  int RecordRate;
  int PlayRate;
  int NumChannels;
  int recordsoundfh; /* recordsoundfh and playsoundfh are the only public members */
  int playsoundfh;
  snd_pcm_t *alsahandle;
  snd_pcm_info_t info;
  snd_pcm_format_t fmt; /* used internally by func's */
  char *recbuffer; /* buffer size must be equal to fragment size */
  int recbufferlen;
  int recbufferpos;

  char *playbuffer;
  int playbufferlen;
  int playbufferpos;

};

#endif

struct soundspec *sound_init(int CardID,int CardDevice,int Mode,int log2fragsize,int log2numfrags);
int sound_setrecordrate(struct soundspec *spec,int *NumChannels,int DesiredRate);
int sound_setplayrate(struct soundspec *spec,int *NumChannels,int DesiredRate);

int sound_readbuf(struct soundspec *spec,INT16 *CurBlock,int Size,int CurPos,int *moreavail,int DebugFlag);
int sound_writebuf(struct soundspec *spec,INT16 *CurBlock,int Size,int CurPos,int *morespace,int DebugFlag);





