/*
     Aglaophone -- a system for real time audio processing
     Copyright (C) 1998-1999 Stephen D. Holland
 
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
 
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.border.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class uf_panel extends JPanel implements ChangeListener,ItemListener,ActionListener {
    static JFrame frame;
    static uf_panel panel;
    
    JFileChooser FilterChooser;
    JFrame FilterFrame;
    JButton PickButton;
    
    static String Title="Upsample and filter";

    public final static Border emptyBorder10 = new EmptyBorder(10,10,10,10);
    static Thread consoleInputThread;
    public final static Dimension hpad10 = new Dimension(10,1);
    public final static Dimension vpad10 = new Dimension(1,10);
    
    JSlider UpsampleFactor;
    
    JCheckBox FilterDisable;
    JTextField FilterFile;
    
    int upsamplefactor=1;
    String filterfile="invalid";
    
    
  void setupsamplefactor(int num) {
    if (num != upsamplefactor) {
      System.out.println("UpsampleFactor="+num);
      upsamplefactor=num;
      UpsampleFactor.setValue(num);
    }
    
  }

    void setfilterfile(String file) {
	/* file should be either "none" or surrounded by quotes */
	if (!file.equals(filterfile)) {
	    if (file.equals("none")) {
		filterfile=file;
		FilterDisable.setSelected(true);
	    }
	    else {
		filterfile=file;
		FilterFile.setText(file.substring(1,file.length()-1));
		FilterDisable.setSelected(false);
	    }
	    System.out.println("filterfile="+file);
	}
    }

  public uf_panel() {
    setBorder(emptyBorder10);
    setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));

    
    //    JPanel HOPanel=new JPanel();
    //HOPanel.setLayout(new BoxLayout(HOPanel,BoxLayout.X_AXIS));

    
    JPanel UpPanel=new JPanel();
    
    JLabel UpLabel=new JLabel("Upsample factor:");
    
    UpPanel.add(UpLabel);

    UpsampleFactor=new JSlider(JSlider.HORIZONTAL,1,8,upsamplefactor);
    UpsampleFactor.addChangeListener(this);
    UpsampleFactor.setPaintTicks(true);
    UpsampleFactor.setMajorTickSpacing(4);
    UpsampleFactor.setMinorTickSpacing(1);

    UpsampleFactor.setPaintLabels( true );
    UpsampleFactor.setSnapToTicks( true );
    UpPanel.add(UpsampleFactor);

    add(UpPanel);
    

    JPanel FilterPanel=new JPanel();
    
    FilterDisable=new JCheckBox("Disable filter",false);
    FilterDisable.setAlignmentX(JCheckBox.LEFT_ALIGNMENT);
    FilterDisable.addItemListener(this);
    FilterPanel.add(FilterDisable);

    JLabel FileLabel=new JLabel("Filter file:");
    FilterPanel.add(FileLabel);

    FilterFile=new JTextField("",14);
    FilterFile.setEditable(true);
    FilterFile.addActionListener(this);
    FilterPanel.add(FilterFile);

    PickButton=new JButton("Pick");
    PickButton.addActionListener(this);
    FilterPanel.add(PickButton);

    add(FilterPanel);

    

    
  }

    public void stateChanged(ChangeEvent event) {
	JComponent c = (JComponent) event.getSource();
	if(c == UpsampleFactor) {
	    if (!UpsampleFactor.getValueIsAdjusting()) {
		setupsamplefactor(UpsampleFactor.getValue());
	    }
	    
	} 
    }
    
    public void itemStateChanged(ItemEvent event) {
	JComponent c = (JComponent) event.getSource();
	if (c==FilterDisable) {
	    if (FilterDisable.isSelected()) {
		setfilterfile("none");
	    } else {
		setfilterfile("\""+FilterFile.getText()+"\"");
	    }
	}
	
    }

    public void actionPerformed(ActionEvent event) {
	JComponent c = (JComponent) event.getSource();
	if (c==FilterFile) {
	    String Selected=FilterFile.getText();
	    setfilterfile("\""+Selected+"\"");
	}
	if (c==PickButton) {
	    if (FilterFrame==null) {
		FilterFrame=new JFrame("Select filter file");
		FilterFrame.setContentPane(new JPanel());
		FilterChooser=new JFileChooser(filterfile.substring(1,filterfile.length()-1));
		FilterChooser.setApproveButtonText("Filter");
		FilterChooser.addActionListener(this);
		FilterFilter myfilter=new FilterFilter();
		FilterChooser.addChoosableFileFilter(myfilter);
		FilterChooser.setFileFilter(myfilter);
		FilterFrame.getContentPane().add(FilterChooser);
		FilterFrame.pack();
		FilterFrame.setVisible(true);
		
	    } else {
		FilterChooser.rescanCurrentDirectory();
		FilterFrame.pack();
		FilterFrame.setVisible(true);
	    }
	}
	if (FilterChooser != null && c==FilterChooser) {
	    FilterFrame.setVisible(false);
	    if (event.getActionCommand().equals("ApproveSelection")) {
		setfilterfile("\""+FilterChooser.getSelectedFile().getPath()+"\"");
	    }
	}
    }
    
    static class ConsoleInput implements Runnable {
	uf_panel panel;
	ConsoleInput(uf_panel parentpanel) {
	    panel=parentpanel;
	}

	public void run() {
      /* console input thread begins here */
	    /**** WARNING **** Practically everything in this thread
		  (except for reading from stdin) must be synchronized
		  with invokeAndWait(). See
		  http://java.sun.com/products/jfc/tsc/archive/tech_topics_arch/threads/threads.html
		  for details. */
	    
	    try {
		Reader r = new BufferedReader(new InputStreamReader(System.in));
		StreamTokenizer st = new StreamTokenizer(r);
		int ttype;
		
		/* Example of invokeandwait(): 
		   
		   SwingUtilities.invokeAndWait(new Runnable() {public void run() {
		   System.out.println("Doing invokeAndWait");
		   }});
		*/
		
		
		st.resetSyntax();
		st.wordChars('a','z');
		st.wordChars('A','Z');
		st.wordChars('\u00A0','\u00ff');
		st.whitespaceChars('\u0000','\u0020');
		st.quoteChar('"');
		st.parseNumbers();
		st.eolIsSignificant(true);
		
		/* read in, and process, tokens */
		
		while ((ttype=st.nextToken()) != st.TT_EOF) {
		    switch(ttype) {
		    case st.TT_EOL:
			break;
			
		    case st.TT_WORD:
			/* System.err.println("Got "+st.sval); */
			if (st.sval.compareTo("UpsampleFactor")==0) {
			    if (st.nextToken()=='=' && st.nextToken()==st.TT_NUMBER) {	
				final int number=(int)st.nval;
				SwingUtilities.invokeAndWait(new Runnable() {public void run() {
				    panel.setupsamplefactor(number);
				}});
			    }
			}
			else if (st.sval.compareTo("filterfile")==0) {
			    if (st.nextToken()=='=') {
				int toktype;
				toktype=st.nextToken();
				if (toktype==st.TT_WORD) {	
				    final String str=st.sval;
				    SwingUtilities.invokeAndWait(new Runnable() {public void run() {
					panel.setfilterfile(str);
				    }});
				} else if (toktype=='"') {
				    final String str=st.sval;
				    SwingUtilities.invokeAndWait(new Runnable() {public void run() {
					panel.setfilterfile("\""+str+"\"");
				    }});
				    
				}
			    }
			}
			else if (st.sval.compareTo("title")==0) {
			    if (st.nextToken()=='=') {
				int toktype;
				toktype=st.nextToken();
				if (toktype=='"') {
				    final String str=st.sval;
				    SwingUtilities.invokeAndWait(new Runnable() {public void run() {
					Title=str;
				    }});
				    
				}
			    }
			}
			else if (st.sval.compareTo("BeginGUI")==0) {
			    SwingUtilities.invokeAndWait(new Runnable() {public void run() {		  
				frame = new JFrame(Title);
				frame.addWindowListener(new WindowAdapter() {
				    public void windowClosing(WindowEvent e) {System.exit(0);}
				});
				frame.getContentPane().add("Center", panel);
				frame.pack();
				/* System.err.println("ready to set visible "); */
				frame.setVisible(true); /* No more GUI stuff allowed after this call, 
							   unless thread-synchronized */
				System.out.println("GUIReady");
			    }});
			}
			break;
			
		    default:
			System.err.println("Got unknown input token: " + ttype);
			
		    }
		}
		System.exit(0);
	    }
	    catch(Exception except) {
		System.err.println("Error in input processing thread: "+except);
	    }
	}
    }
    
    
    public static void main(String s[]) {
	ConsoleInput consoleInput;
	
	
	/* System.err.println("main started "); */
	
	try {
	    //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
	    UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
	    //UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
	} catch (Exception exc) {
	    System.err.println("Error loading Look&Feel: " + exc);
	}
	
	
	panel = new uf_panel();
	/* System.err.println("sio_panel created "); */
	
	
	/* start up the control-input thread */
	
	consoleInput = new ConsoleInput(panel);
	consoleInputThread=new Thread(consoleInput);
	consoleInputThread.start();
    }
}

