#ifndef UFPI_H
#define UFPI_H

void init_ufpi(void);
void ufpi(void);
typedef enum {
  ufpi_panelinterface_token = 1, ufpi_line_token,
  ufpi_unsigned_integer_token = 6, ufpi_QuotedString_token = 8,
  ufpi_DIGIT_token = 10, ufpi_DequotedString_token = 12,
  ufpi_QuotedStringChar_token
} ufpi_token_type;

typedef struct {
  ufpi_token_type token_number, reduction_token, error_frame_token;
  int input_code;
  int input_value;
  int line, column;
  int ssx, sn, error_frame_ssx;
  int drt, dssx, dsn;
  int ss[32];
  int vs[32];
  int bts[32], btsx;
  unsigned char * pointer;
  unsigned char * la_ptr;
  int lab[16], rx, fx;
  const unsigned char *key_sp;
  int save_index, key_state;
  char *error_message;
  char read_flag;
  char exit_flag;
} ufpi_pcb_type;


#ifndef PRULE_CONTEXT
#define PRULE_CONTEXT(pcb)  (&((pcb).cs[(pcb).ssx]))
#define PERROR_CONTEXT(pcb) ((pcb).cs[(pcb).error_frame_ssx])
#define PCONTEXT(pcb)       ((pcb).cs[(pcb).ssx])
#endif


#ifndef AG_RUNNING_CODE_CODE
/* PCB.exit_flag values */
#define AG_RUNNING_CODE         0
#define AG_SUCCESS_CODE         1
#define AG_SYNTAX_ERROR_CODE    2
#define AG_REDUCTION_ERROR_CODE 3
#define AG_STACK_ERROR_CODE     4
#define AG_SEMANTIC_ERROR_CODE  5
#endif

extern ufpi_pcb_type ufpi_pcb;
#endif

