#ifndef VPP_H
#define VPP_H

void init_vpp(void);
void vpp(void);
typedef union {
  double alignment;
  char ag_vt_2[sizeof(int)];
  char ag_vt_4[sizeof(unsigned)];
} vpp_vs_type;

typedef enum {
  vpp_ConfigFile_token = 5, vpp_ws_token, vpp_Sections_token = 9,
  vpp_EOF_token, vpp_whitespace_token, vpp_anythingbuteof_token,
  vpp_anythingbuteol_token = 16, vpp_Section_token = 20,
  vpp_ModuleSection_token, vpp_ConnectionSection_token,
  vpp_FileSection_token, vpp_String_token = 25, vpp_FileData_token = 28,
  vpp_FileDatum_token = 30, vpp_argument_token = 32,
  vpp_modespec_token = 34, vpp_ModuleData_token = 40, vpp_ModuleDatum_token,
  vpp_QuotedString_token = 46, vpp_CommandLineOption_token,
  vpp_unsigned_integer_token = 49, vpp_Digit_token,
  vpp_ConnectionData_token = 52, vpp_ConnectionDatum_token,
  vpp_ConnectionSide_token, vpp_Unsigned_token = 56,
  vpp_StringCharNonDigit_token, vpp_StringChar_token,
  vpp_DequotedString_token = 60, vpp_QuotedStringChar_token
} vpp_token_type;

typedef struct {
  vpp_token_type token_number, reduction_token, error_frame_token;
  int input_code;
  int input_value;
  int line, column;
  int ssx, sn, error_frame_ssx;
  int drt, dssx, dsn;
  int ss[34];
  vpp_vs_type vs[34];
  int bts[34], btsx;
  unsigned char * pointer;
  unsigned char * la_ptr;
  int lab[12], rx, fx;
  const unsigned char *key_sp;
  int save_index, key_state;
  char *error_message;
  char read_flag;
  char exit_flag;
} vpp_pcb_type;


#ifndef PRULE_CONTEXT
#define PRULE_CONTEXT(pcb)  (&((pcb).cs[(pcb).ssx]))
#define PERROR_CONTEXT(pcb) ((pcb).cs[(pcb).error_frame_ssx])
#define PCONTEXT(pcb)       ((pcb).cs[(pcb).ssx])
#endif


#ifndef AG_RUNNING_CODE_CODE
/* PCB.exit_flag values */
#define AG_RUNNING_CODE         0
#define AG_SUCCESS_CODE         1
#define AG_SYNTAX_ERROR_CODE    2
#define AG_REDUCTION_ERROR_CODE 3
#define AG_STACK_ERROR_CODE     4
#define AG_SEMANTIC_ERROR_CODE  5
#endif

extern vpp_pcb_type vpp_pcb;
#endif

